var FrameworkApp = angular.module('Framework', [
      'ui.router'
    , 'ui.bootstrap'
    , 'ngAnimate'
    , 'ngTouch'
    , 'angular-bootstrap-select'
    , 'vAccordion'
    , 'angular-carousel-3d'
    , 'ngSanitize'
    , 'ngDragDrop'
]);

////////////////////////////////////////////////////////
//Module config
////////////////////////////////////////////////////////
FrameworkApp.config(['$stateProvider', '$urlRouterProvider', '$locationProvider', function ($stateProvider, $urlRouterProvider, $locationProvider) {
    $stateProviderReference = $stateProvider;
    $urlRouterProviderReference = $urlRouterProvider;
}]);

////////////////////////////////////////////////////////
//Module run
////////////////////////////////////////////////////////
FrameworkApp.run(['$rootScope', '$state', '$stateParams', '$location', '$http', '$timeout', 'PreloaderService', '$modal','$interval', function ($rootScope, $state, $stateParams, $location, $http, $timeout, PreloaderService, $modal,$interval) {
    $rootScope.$state = $state;
    $rootScope.$stateParams = $stateParams;
    $rootScope.slideDirection = "Next";
    $rootScope.currentModule = 0;
    $rootScope.currentTopic = 0;
    $rootScope.currentPage = 0;
    $rootScope.totalPages = 0;
    $rootScope.currentPageNumber = 0;
    $rootScope.branchingCounter = 0;
    $rootScope.pageStatusList = [];
    $rootScope.cPageData = '01|01';
    $rootScope.clickedNextButton = false;
    $rootScope.clickedBackButton = false;
    $rootScope.showResumeBtn = false;
    $rootScope.isPreLoading = true;
    $rootScope.isPreLoadSuccessful = false;
    $rootScope.isRendered = false;
    $rootScope.percentLoaded = 0;
    $rootScope.lastPage = false;
    $rootScope.assesmentQuestionIndex = [];
    $rootScope.assesmentScore = 0;
    $rootScope.assesmentStarted = false;
    $rootScope.assesmentAttempted = 0;
    $rootScope.selectedLang = "en";
    $rootScope.deviceUrl = "../html5/Views/";
    $rootScope.isNextButtonDisabled = true;
    $rootScope.isPrevButtonDisabled = false;
    $rootScope.isLangPage = false;
    $rootScope.pageCount = 0;
    $rootScope.assesmentPercentageScore = 0;
	$rootScope.screenType = "";
	$rootScope.isAudio = "";
	$rootScope.audioFile = "";
	$rootScope.isSoundon = true;
	$rootScope.isPaused = false;
	$rootScope.assesmentAnswerArray = [2,2,2,2,2];
	$rootScope.allIntevals = [];
	$rootScope.IE = false;
	$rootScope.windowWidth = window.innerWidth;
	$rootScope.synCPaused = false;
	var ua = navigator.userAgent.toLowerCase();
	$rootScope.vdoControls = false;
	$rootScope.isAndroid = ua.indexOf("android") > -1; //&& ua.indexOf("mobile");
	if($rootScope.isAndroid)
		$rootScope.vdoControls = true;
	
	if (window.innerWidth <= 767) {
        $rootScope.deviceUrl = "../html5/Views/mobile"
    }
	var BrowserDetect = {
			init: function () {
				this.browser = this.searchString(this.dataBrowser) || "Other";
				this.version = this.searchVersion(navigator.userAgent) || this.searchVersion(navigator.appVersion) || "Unknown";
			},
			searchString: function (data) {
				for (var i = 0; i < data.length; i++) {
					var dataString = data[i].string;
					this.versionSearchString = data[i].subString;

					if (dataString.indexOf(data[i].subString) !== -1) {
						return data[i].identity;
					}
				}
			},
			searchVersion: function (dataString) {
				var index = dataString.indexOf(this.versionSearchString);
				if (index === -1) {
					return;
				}

				var rv = dataString.indexOf("rv:");
				if (this.versionSearchString === "Trident" && rv !== -1) {
					return parseFloat(dataString.substring(rv + 3));
				} else {
					return parseFloat(dataString.substring(index + this.versionSearchString.length + 1));
				}
			},

			dataBrowser: [
				{string: navigator.userAgent, subString: "Chrome", identity: "Chrome"},
				{string: navigator.userAgent, subString: "MSIE", identity: "Explorer"},
				{string: navigator.userAgent, subString: "Trident", identity: "Explorer"},
				{string: navigator.userAgent, subString: "Firefox", identity: "Firefox"},
				{string: navigator.userAgent, subString: "Safari", identity: "Safari"},
				{string: navigator.userAgent, subString: "Opera", identity: "Opera"}
			]

		};		
		BrowserDetect.init();
	if(BrowserDetect.browser.toLowerCase() == 'explorer')
		$rootScope.IE = true;
	
    GetConfigData = function () {
        return $http.get('../course_config.json')
            .success(function (data) {
                $rootScope.configData = data;

            });
    };
 $rootScope.selectedLanguage = function(){
		$rootScope.selectedLang = event.target.value;
		//console.log("slec"+$rootScope.selectedLang)
		$http.get('../course_content/'+$rootScope.selectedLang+'/langSelection.json').
		then(function (response) {			
			$rootScope.languageSelectContent = response.data;
			console.log($rootScope.selectedLang );
		$http.get('../course_content/' + $rootScope.selectedLang + '/coursemenu.json').
			then(function (response) {
				$rootScope.CourseMenu = response.data;
		});
				
		}, function (response) {
		});
		$http.get('../course_content/' + $rootScope.selectedLang + '/visualmenu.json').
		then(function (response) {			
				$rootScope.VisualMenuContent = response.data;			
			}, function (response) {
		});
	}; 
    GetConfigData().success(function (data) {
        $rootScope.CourseConfig = {
            CourseName: data.CourseName,
            CourseBrand: data.CourseBrandName,
            BrandFont: data.CourseBrandFontSize,
            LogoPath: data.CourseBrandNameImg,
            AppType: data.courseSettings.appType,
            VisualMenu: data.courseSettings.visualMenu,
            SkipVisualmenu: data.courseSettings.skipVisualMenu,
            MenuDepth: data.courseSettings.menuDepth,
            UIControls: data.UIControllers,
            ForceNavigation: data.courseSettings.forceNavigation,
            HasAssessment:data.courseSettings.hasAssessment,
            AssessmentSection:data.courseSettings.assessmentSection,
            TotalAssesmentQuestions: data.courseSettings.totalQuestions,
            AvailableAssessmentQuestion : data.courseSettings.availableQuestions,
            IsRandomized: data.courseSettings.hasRandomization,
            HasPooling: data.courseSettings.hasPooling,
            MasteryScore: data.courseSettings.masteryScore,
            HasAssesmentIntro: data.courseSettings.hasAssessmentIntro,
            MaxAssesmentAttempt: data.courseSettings.maxAssesmentAttempt,
            HasLangSelectionPage: data.courseSettings.hasLangSelectionPage,
            HasIntroPage: data.courseSettings.hasCourseIntro,
            HasAudio: data.courseSettings.hasAudio,
            PageCount: data.courseSettings.pageCountType
        };
        if ($rootScope.CourseConfig.AppType.toLowerCase() == 'scorm1.2') {
            scormAdaptor_getAPI();
            scormAdaptor_adlOnload();
        }
        init();
    });

    $rootScope.$watch('[]', function () {
        PreloaderService
            .preloadImages()
            .then(
            // == Preloaded images success resolve handler
            function handleResolve() {
                //$timeout(function () {
					$rootScope.isPreLoading = false;
					$rootScope.isPreLoadSuccessful = true;
              //  },1000);
            },
            // == Preloaded images reject  handler
            function handleReject() {
                $rootScope.isPreLoading = false;
                $rootScope.isPreLoadSuccessful = false;
            },
            // == Preloaded images notify handler which is executed multiple times during preload
            function handleNotify(event) {
                $rootScope.percentLoaded = event.percent;
            }
        );

    }, true);

    $stateProviderReference
        .state('/', {
            url: '/',
            templateUrl: '../html5/Views/start.html',
            controller: 'Intro',
        })

        .state('course', {
            url: "/course",
            controller: 'Config',
            templateUrl: $rootScope.deviceUrl + '/home.html'
        })
        .state('route', {
            url: "/route",
            controller: 'Intro',
            templateUrl: function(){
				//console.log('../html5/Views/screens/'+$rootScope.selectedLang+ '/route.html');
				return '../html5/Views/screens/'+$rootScope.selectedLang+ '/route.html';
			}
        })

        .state('intro', {
            url: "/intro",
            controller: 'Intro',
            templateUrl: $rootScope.deviceUrl + '/intro.html'
        })

        .state('menu', {
            url: "/menu",
            controller: 'map',
            templateUrl: $rootScope.deviceUrl+'/visual_menu.html'
        })

        .state('course.pages', {
            url: "/page/:id",
            views: {
                'page-container': {
                    controller: 'Config', templateUrl: function ($stateParams) {
                        var ids = $stateParams.id.split("_");
						$("#preloadericon").html('<img src="../course_images/pages/loader.gif">');
						$timeout(function(){$("#preloadericon").html('')},500)
						//console.log('/page/:id')
                        if (window.innerWidth <= 760 || window.innerHeight <= 600) {
                            return ('../html5/Views/screens/' + $rootScope.selectedLang + '/m' + ids[0] + '/t' + ids[1] + '/s' + ids[2] + '.html');
                        }
                        else
                            return ('../html5/Views/screens/' + $rootScope.selectedLang + '/m' + ids[0] + '/t' + ids[1] + '/s' + ids[2] + '.html');						
                    }
                }
            }
        });
	
    $urlRouterProviderReference.otherwise('/');		
    $location.path('/page/:id').replace();
	

function init() {
	$http.get('../course_content/' + $rootScope.selectedLang + '/langSelection.json').
		then(function (response) {			
			$rootScope.languageSelectContent = response.data;			
		}, function (response) {
	});
    //Get Course Menu Data in json format
    $http.get('../course_content/' + $rootScope.selectedLang + '/coursemenu.json').
        then(function (response) {
            $rootScope.CourseMenu = response.data;
			console.log($rootScope.CourseMenu);
			console.log('../course_content/' + $rootScope.selectedLang + '/coursemenu.json');
            $rootScope.topicTitle = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].name;
            $rootScope.pageStatusList = new Array($rootScope.CourseMenu.module.length);
            for (i = 0; i < $rootScope.CourseMenu.module.length; i++) {
                $rootScope.pageStatusList[i] = new Array($rootScope.CourseMenu.module[i].topics.length);
                for (j = 0; j < $rootScope.CourseMenu.module[i].topics.length; j++) {
                    $rootScope.pageStatusList[i][j] = new Array();
                        if($rootScope.CourseConfig.HasAssessment && j == $rootScope.CourseConfig.AssessmentSection-1){
                            for (k = 0; k < $rootScope.CourseConfig.AvailableAssessmentQuestion+1; k++) {
                                $rootScope.pageStatusList[i][j][k] = "0";
                            }
                        }
                    else {
                        for (k = 0; k < $rootScope.CourseMenu.module[i].topics[j].pages.length; k++) {
                            $rootScope.pageStatusList[i][j][k] = "0";
                        }
                    }
                }
            }
            if (!$rootScope.CourseConfig.HasIntroPage && !$rootScope.CourseConfig.HasLangSelectionPage){
                if ($rootScope.CourseConfig.AppType.toLowerCase() == 'scorm1.2') {
                    $rootScope.getLMSData();
                }
                else {
                    if ($rootScope.CourseConfig.VisualMenu) {
                        $rootScope.$state.go('menu');
                    }
                    else {
                        $rootScope.currentModule = 0;
                        $rootScope.currentTopic = 0;
                        $rootScope.currentPage = 0;
                        var page_id = "01_01_01"
                        $rootScope.$state.go('course.pages', {id: page_id});
                    }
                }
            }
        }, function (response) {

        });


    $rootScope.$on("$locationChangeStart", function (event, next, current) {
		clearInterval(timerFlag);
		$(".next").removeClass("done");
		angular.forEach($rootScope.allIntevals, function(interval) {
			$interval.cancel(interval);
		});
		$rootScope.allIntevals = [];
		$rootScope.synCPaused = false;
		$interval.cancel()
        if( $rootScope.currentTopic == $rootScope.CourseConfig.AssessmentSection-1)
			{
				if($rootScope.pad($rootScope.assesmentQuestionIndex[$rootScope.currentPage])==undefined){
					var tURL = '../course_content/' + $rootScope.selectedLang + '/m' + $rootScope.pad($rootScope.currentModule + 1) + '/t' + $rootScope.pad($rootScope.currentTopic + 1) + '/p0' +1  + '.json';					
				}
				else{
					var tURL = '../course_content/' + $rootScope.selectedLang + '/m' + $rootScope.pad($rootScope.currentModule + 1) + '/t' + $rootScope.pad($rootScope.currentTopic + 1) + '/p' + $rootScope.pad($rootScope.assesmentQuestionIndex[$rootScope.currentPage]) + '.json';
				}
			}
        else{
			 var tURL = '../course_content/' + $rootScope.selectedLang + '/m' + $rootScope.pad($rootScope.currentModule + 1) + '/t' + $rootScope.pad($rootScope.currentTopic + 1) + '/p' + $rootScope.pad($rootScope.currentPage + 1) + '.json';
		}
        $http.get(tURL).
            then(function (response) {
                $rootScope.CourseContent = response.data.contents;
                if( $rootScope.currentTopic == $rootScope.CourseConfig.AssessmentSection-1  && $rootScope.currentPage < $rootScope.assesmentQuestionIndex.length-1){
                    $rootScope.CourseContent.pageHeading = $rootScope.CourseContent.pageHeading.split(' ')[0] + " "+ ($rootScope.currentPage+1);
                }
				$rootScope.screenType = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].screenType;
				$rootScope.isAudio = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].isAudio;
				$rootScope.isTranscript = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].isTranscript;
                if ($rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] != "1") {
                    if ($rootScope.CourseConfig.ForceNavigation)
                        $rootScope.isNextButtonDisabled = true;
					else {
                        if ($rootScope.currentTopic != $rootScope.CourseConfig.AssessmentSection-1)
                            $rootScope.isNextButtonDisabled = false;
                    }
					if($rootScope.currentTopic != $rootScope.CourseConfig.AssessmentSection-1){
                        $rootScope.isPrevButtonDisabled = false;
                    }

                }
                else {
                    if (!$rootScope.CourseContent.branchingScreen && $rootScope.currentTopic != $rootScope.CourseConfig.AssessmentSection-1)
                        $rootScope.isNextButtonDisabled = false;
                }
                if($rootScope.currentTopic != $rootScope.CourseConfig.AssessmentSection-1){
                    $rootScope.isPrevButtonDisabled = false;
                }
			
                if ($rootScope.isAudio == "false" && $rootScope.screenType == "static" && $location.path().indexOf("_") != -1) {
                  
					$rootScope.markVisitedPage();
                }
                if ($rootScope.currentModule == 0 && $rootScope.currentTopic == 0 && $rootScope.currentPage == 0) {
                    $rootScope.isPrevButtonDisabled = true;
                }
                else {
                    if (!$rootScope.CourseContent.branchingScreen && $rootScope.currentTopic != $rootScope.CourseConfig.AssessmentSection-1)
                        $rootScope.isPrevButtonDisabled = false;

                }
                if($rootScope.CourseContent.branchingScreen)
                    $rootScope.isPrevButtonDisabled = true;
            }, function (response) {
            });
        getTotalPagesCount();
        getCurrentPagesCount();
    });

     var getTotalPagesCount = function () {
        var _totalPageCount = 0;
        if ($rootScope.CourseConfig.PageCount == "topicwise")
            $rootScope.totalPages = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages.length;
        else {
            if ($rootScope.CourseConfig.MenuDepth == 2) {
                if($rootScope.CourseConfig.HasAssessment) {
                    for (var i = 0; i < $rootScope.CourseMenu.module[$rootScope.currentModule].topics.length; i++) {
                        if(i == $rootScope.CourseConfig.AssessmentSection-1) {
                                    _totalPageCount = _totalPageCount + $rootScope.CourseConfig.AvailableAssessmentQuestion + 1;
                            if($rootScope.CourseConfig.HasAssesmentIntro)
                                _totalPageCount++;
                        }
                        else{
                            for (var j = 0; j < $rootScope.CourseMenu.module[$rootScope.currentModule].topics[i].pages.length; j++) {
                                    _totalPageCount++;
                            }
                        }
                    }
                }
            }
           // $rootScope.totalPages = _totalPageCount;
			 $rootScope.totalPages = getTotalPagenumber();
        }
    }

    var getCurrentPagesCount = function () {
        if ($rootScope.CourseConfig.PageCount == "topicwise")
            $rootScope.currentPageNumber = $rootScope.currentPage;
        else{
            var pageCounter = 0;
            for (var i = 0; i < $rootScope.CourseMenu.module[$rootScope.currentModule].topics.length; i++)
            {
                if ($rootScope.currentTopic == i)
                {
                    pageCounter += $rootScope.currentPage;break;
                }
                else
                {
                    pageCounter += $rootScope.CourseMenu.module[$rootScope.currentModule].topics[i].pages.length;
                }
            }
				pageCounter = pageCounter+1;
            $rootScope.currentPageNumber =  getCurrentPageNumber(pageCounter);
           // $rootScope.currentPageNumber =  pageCounter;
        }
    }


	// addedd by sinchu to remove the branmching screens from the page count
	function getTotalPagenumber(){
	var _totalPageCount  = 0;
	for(var i = 0; i < $rootScope.CourseMenu.module[$rootScope.currentModule].topics.length; i++){
		for(var j = 0; j < $rootScope.CourseMenu.module[$rootScope.currentModule].topics[i].pages.length; j++){
			if(!$rootScope.CourseMenu.module[$rootScope.currentModule].topics[i].pages[j].branchingScreen)
				_totalPageCount++;
		}
	}
	var flag2 = 0;
	if($rootScope.CourseConfig.HasPooling){
		flag2 = $rootScope.CourseConfig.TotalAssesmentQuestions - $rootScope.CourseConfig.AvailableAssessmentQuestion;
	}
	_totalPageCount = _totalPageCount - flag2;
	return _totalPageCount;
	}

	function getCurrentPageNumber(_val){
	var _totalPageCount  = 0;
	var flag = 0;
	for(var i = 0; i < $rootScope.CourseMenu.module[$rootScope.currentModule].topics.length; i++){
		for(var j = 0; j < $rootScope.CourseMenu.module[$rootScope.currentModule].topics[i].pages.length; j++){
			if(flag!=_val){

				if(!$rootScope.CourseMenu.module[$rootScope.currentModule].topics[i].pages[j].branchingScreen)
					_totalPageCount++;

			}
			else{

				break;
			}
			flag++;

		}
	}
	return _totalPageCount;
	}


    $rootScope.$on("$locationChangeSuccess", function (event, next, current) {
        $rootScope.isPreLoading = false;
        $rootScope.isPreLoadSuccessful = true;
		$rootScope.isPaused = false;
        $rootScope.isRendered = true;
        $rootScope.percentLoaded = 0;
        if ($location.path() != '/menu' && $location.path() != "'/'" && $rootScope.pageStatusList.length > 0 && $location.path() != "/route") {
			if($rootScope.CourseConfig.HasAudio) {
				$rootScope.isAudio = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].isAudio;
				if($rootScope.isAudio=="true"){
				$rootScope.audioFile.play();
				}
			}
          
        }
    });

    //Get Visual menu Content
    $http.get('../course_content/' + $rootScope.selectedLang + '/visualmenu.json').
        then(function (response) {
            $rootScope.VisualMenuContent = response.data;
            //console.log('$rootScope.pageStatusList in app.js: ' + $rootScope.pageStatusList);
        }, function (response) {
        });

    $http.get('../course_content/' + $rootScope.selectedLang + '/resources.json').
        then(function (response) {
            $rootScope.ResourceContent = response.data;
        }, function (response) {
        });

    $http.get('../course_content/' + $rootScope.selectedLang + '/help.json').
        then(function (response) {
            $rootScope.HelpContent = response.data;
        }, function (response) {
        });

    $rootScope.pad = function (n) {
        return (n < 10) ? ("0" + n) : n;
    }
	var timerFlag ;
	function myTimer(){		
	
		$(".next").addClass("done"); 
		clearInterval(timerFlag);
		
	}
    $rootScope.markVisitedPage = function () {
			$rootScope.screenType = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].screenType;
			$rootScope.isAudio = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].isAudio; 
			if ($rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] != "1") {
           
				if ($rootScope.isAudio == "false" && $rootScope.screenType == "static") {
                    timerFlag = setInterval(function(){ myTimer() }, 2000);
                }
				else{
					$(".next").addClass("done");
				}


        }
        $rootScope.pageStatusList[$rootScope.currentModule][$rootScope.currentTopic][$rootScope.currentPage] = "1";
        if (!$rootScope.CourseContent.branchingScreen)
            $rootScope.isNextButtonDisabled = false;
        $rootScope.updateCourseProgress();
    };

    $rootScope.pageVisited = function (m, t, p) {
        if ($rootScope.CourseConfig.ForceNavigation) {
            if ($rootScope.pageStatusList[m][t][p] == "1")
                return "enable-menu-list";
            else
                return "disable-menu-list";
        }
    }
	
	/////////////////////////////////////////////////
	///for opening links in new window
	/////////////////////////////////////////////////
	openLinkInNewWindow = function(link){
		myWindow=window.open(link, "myWindow", "width=1015, height=672,resizable=yes,scrollbars=yes");
	}
	
	
    $rootScope.viewedPage = function (m, t, p) {
        var currentPath = $location.path().split("/")[3];
        var cModule = currentPath.split("_")[0] - 1;
        var cTopic = currentPath.split("_")[1] - 1;
        var cPage = currentPath.split("_")[2] - 1;
        if($rootScope.CourseContent.branchingScreen){
            $("#0"+"_"+t+"_"+($rootScope.CourseContent.branchingHomeScreen-1)).addClass("current-page");
        }
        if(m == cModule && t == cTopic && p == cPage){
            return "current-page"
        }
    }

    //Bootstrapp modal instaciate
    var ModalInstanceCtrl = function ($scope, $modalInstance) {
        $scope.ok = function () {
            $modalInstance.close();
        };

        $scope.cancel = function () {
            $modalInstance.dismiss('cancel');
			if($rootScope.isAudio == "true" && $rootScope.isPaused && !$rootScope.synCPaused){
				$rootScope.audioFile.play();
			}
        };
    };

    $rootScope.viewedTopic = function (m, t) {
        var currentPath = $location.path().split("/")[3];
        var cModule = currentPath.split("_")[0] - 1;
        var cTopic = currentPath.split("_")[1] - 1;
        var cPage = currentPath.split("_")[2] - 1;
        if(m == cModule && t == cTopic){
            return "current-topic"
        }

    }

    //Event triggered on click of RESOURCE button
    $rootScope.loadResources = function () {
        var modalInstance = $modal.open({
            animation: $rootScope.animationsEnabled,
            templateUrl: '../html5/Views/resource.html',
            controller: ModalInstanceCtrl,
            backdrop: 'static',
            keyboard: false

        });
    };

	$rootScope.AudioAutoPlay =  function(pageType,pageId){
		if($rootScope.CourseConfig.HasAudio) {
				$rootScope.audioFile = document.getElementById('course-audio');
				$rootScope.audioFile.src = "";
				var audioSrc ;
				if(pageType=="page"){
				audioSrc  = '../course_audio/' + $rootScope.selectedLang + '/m' + $rootScope.pad($rootScope.currentModule + 1) + '/t' + $rootScope.pad($rootScope.currentTopic + 1) + '/p' + $rootScope.pad($rootScope.currentPage + 1) + '.mp3';
				}
				if(pageType=="intro"){
				audioSrc = '../course_audio/intro/intro.mp3';
				}
				$rootScope.isAudio = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].isAudio;
				$rootScope.isTranscript = $rootScope.CourseMenu.module[$rootScope.currentModule].topics[$rootScope.currentTopic].pages[$rootScope.currentPage].isTranscript;
				if($rootScope.isAudio=="true"){
					
				$rootScope.audioFile.src = audioSrc;
				$rootScope.audioFile.load();
				$rootScope.audioFile.addEventListener('loadeddata', $rootScope.LoadContent(pageType,pageId));
				$rootScope.audioFile.addEventListener('ended', function(){
				$rootScope.AudioFinishedPlaying();
				$rootScope.synCPaused = true;				
				});
					
				}
				else{
					$rootScope.LoadContent(pageType,pageId)	;
					$rootScope.audioFile.pause();
					//console.log("false")
				}
                
            }else{
				
				$rootScope.LoadContent(pageType,pageId)
				
			}
	}
	$rootScope.LoadContent = function(pageType,pageId){
		if(pageType=="page"){			
			$rootScope.$state.go('course.pages', { id: pageId });
		}
		if(pageType=="intro"){
			 $rootScope.$state.go('intro');
		}
		$rootScope.audioFile.removeEventListener('loadeddata', $rootScope.LoadContent);
	}
	
	$rootScope.AudioFinishedPlaying = function(){
		if($rootScope.screenType == "static"){			
			$rootScope.markVisitedPage();
			$rootScope.$apply();
		}
	}
    //Event triggered on click of HELP button
    $rootScope.loadHelp = function () {
        var modalInstance = $modal.open({
            animation: $rootScope.animationsEnabled,
            templateUrl: '../html5/Views/screens/' + $rootScope.selectedLang + '/help.html',
            controller: ModalInstanceCtrl,
            windowClass: "modal fade in",
            backdrop: 'static',
            keyboard: false
        });
		if($rootScope.isAudio == "true" && (!$rootScope.audioFile.ended || ! $rootScope.audioFile.paused)){
			$rootScope.audioFile.pause();
			$rootScope.isPaused = true;
		}
        $('.modal-backdrop').find('body').css('overflow-y','hidden');
    };

    //Event triggered on click of Menu button if Visual menu set to true
    $rootScope.loadVisualMenu = function () {
        $rootScope.$state.go('menu');
        if ($rootScope.pageStatusList[$rootScope.currentModule].join("").indexOf(1) == -1)
            $rootScope.showResumeBtn = false;
        else
            $rootScope.showResumeBtn = true;
		$rootScope.audioFile = document.getElementById('course-audio');
		$rootScope.audioFile.src = "";
    };
	
	$rootScope.createAssessment = function(){
			$rootScope.assesmentQuestionIndex = [];
			if ($rootScope.CourseConfig.IsRandomized) {
				if ($rootScope.CourseConfig.HasAssesmentIntro) {
				}else{
					while ($rootScope.assesmentQuestionIndex.length < $rootScope.CourseConfig.AvailableAssessmentQuestion) {
						var tRandomNumber = Math.floor(Math.random() * $rootScope.CourseConfig.TotalAssesmentQuestions-1) + 2;
						if ($rootScope.assesmentQuestionIndex.indexOf(tRandomNumber) == -1 )
							$rootScope.assesmentQuestionIndex.push(tRandomNumber);
					}
					$rootScope.assesmentQuestionIndex.push($rootScope.CourseConfig.TotalAssesmentQuestions+1);
				}
			}	
			else{
				
				for (i = 1; i <= $rootScope.CourseConfig.AvailableAssessmentQuestion; i++) {
					$rootScope.assesmentQuestionIndex.push(i);
				}
				$rootScope.assesmentQuestionIndex.push($rootScope.CourseConfig.TotalAssesmentQuestions+1);
			}
	};
	/****** assessment random array creation ****/
	$rootScope.createAssessment();
}

    /////////////////////////////////////////////////
    ///LMS
    /////////////////////////////////////////////////
	$rootScope.closequizFeedback = function(){
			$rootScope.gotoNextQuiz();
		// $rootScope.feedbackToggle = false;
	};

    $rootScope.updateCourseProgress = function () {
        //console.log($rootScope.currentPage);
        //$rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] = 1;
        $rootScope.cPageData = $rootScope.pad($rootScope.currentTopic + 1) + '|' + $rootScope.pad($rootScope.currentPage + 1);
        //setLMSData($rootScope.pageStatusList, $rootScope.cPageData, $rootScope.CourseConfig.AppType);
        $rootScope.setLMSData();
        //$rootScope.checkForCompletion();
    };
	
	$rootScope.playPlaneSoud = function(){
		var plainSound = document.getElementById('playAudio');
			plainSound.src = "../audio/Airport_Noise.mp3";
			plainSound.load();
			plainSound.loop = true;
			plainSound.play();
	};
	$rootScope.stopPlaneSoud = function(){
		var plainSound = document.getElementById('playAudio');
			plainSound.pause();
	};

    $rootScope.setLMSData = function () {
        if ($rootScope.CourseConfig != undefined) {
            var _psList = ($rootScope.CourseConfig.MenuDepth == 2) ? $rootScope.pageStatusList[0] : $rootScope.pageStatusList;
            var _susData = "course_progress=" + String(_psList.join('|'));
            if ($rootScope.CourseConfig.AppType.toLowerCase() == 'scorm1.2') {
                scormAdaptor_setsuspenddata(_susData);
                scormAdaptor_setlocation($rootScope.cPageData);
                scormAdaptor_commit();
            }
        }
    };

    $rootScope.checkForCompletion = function () {
        var _count = 0;
        var _len = 0;
        if ($rootScope.CourseConfig != undefined) {
            if ($rootScope.CourseConfig.MenuDepth == 2) {
                for (var i = 0; i < $rootScope.pageStatusList[0].length; i++) {
                    _len += $rootScope.pageStatusList[0].length;
                    for (var j = 0; j < $rootScope.pageStatusList[0][i].length; j++) {
                        if ($rootScope.pageStatusList[0][i][j] == "1") _count++;
                    }
                }
            } else {
                for (var i = 0; i < $rootScope.pageStatusList.length; i++) {
                    for (var j = 0; j < $rootScope.pageStatusList[i].length; j++) {
                        _len += $rootScope.pageStatusList[i].length;
                        for (var k = 0; k < $rootScope.pageStatusList[j].length; k++) {
                            if ($rootScope.pageStatusList[i][j][k] == "1") _count++;
                        }
                    }
                }
            }
            _len += 1;
           // if ($rootScope.pageStatusList.join('').indexOf("0") == -1) scormAdaptor_complete();
        }
    }
}]);




